TRT - Treats for the Cows


FJ has purchased N (1 <= N <= 2000) yummy treats for the cows who get money for giving vast amounts of milk. FJ sells one treat per day and wants to maximize the money he receives over a given period time. The treats are interesting for many reasons:

  • The treats are numbered 1..N and stored sequentially in single file in a long box that is open at both ends. On any day, FJ can retrieve one treat from either end of his stash of treats.
  • Like fine wines and delicious cheeses, the treats improve with age and command greater prices.
  • The treats are not uniform: some are better and have higher intrinsic value. Treat i has value v(i) (1 <= v(i) <= 1000).
  • Cows pay more for treats that have aged longer: a cow will pay v(i)*a for a treat of age a.

Given the values v(i) of each of the treats lined up in order of the index i in their box, what is the greatest value FJ can receive for them if he orders their sale optimally?

The first treat is sold on day 1 and has age a=1. Each subsequent day increases the age by 1.

Input

Line 1: A single integer, N

Lines 2..N+1: Line i+1 contains the value of treat v(i)

Output

The maximum revenue FJ can achieve by selling the treats

Example

Input:
5
1
3
1
5
2

Output:
43

hide comments
med128ali: 2023-08-08 12:42:15

<snip>
guys can you help me what is wrong with my solution
[Simes]: use the forum code this, don't post code here

Last edit: 2023-08-08 15:10:34
nr0728: 2022-08-15 15:10:39

Don\'t use greedy. Your program will be WA.

nr0728: 2022-08-15 15:08:48

This problem maybe has testdatas limit description exceeded. because if my array is v[3000] & dp[3000][3000], my program is AC. else if my array is v[2000] & dp[2000][2000], my program is RE.

re: [Simes]: there are no N greater than 2000. I've just proven this via asserts.

Last edit: 2022-08-16 14:42:18
nr0728: 2022-08-15 15:01:42

Why my solution in spoj is runtime error? My solution in Luogu(https://www.luogu.com.cn/record/83926418) is accepted!! but this problem is very good for cpp newbies.

mohit_010: 2021-11-18 18:38:06

its great question for dp beginer because i am also a beginer spent a lot of time with own approach but failed , tried googling out , nice explanation in quora tried that succeeded

chirag2505: 2021-07-28 12:32:11

Why map is giving TLE in this problem? But using 2D dp of fixed size got accepted?

vatsalrocker: 2021-07-08 18:06:14

Go for MCM!

null12_21: 2021-06-08 20:45:08

use recursion with memorization

wille_25: 2021-03-12 12:20:53

AC in two GO ..avoid memset function!

baljot: 2020-10-26 06:09:25

first think of n3 solution then convert it into n2 (how we get age from segment l to r) these type of problem are variation of mcm where smaller interval is processed first then we solve for bigger interval ps try to do iterative


Added by:Nguyen Van Quang Huy
Date:2006-02-15
Time limit:1s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: NODEJS PERL6 VB.NET
Resource:USACO FEB06 Gold Division